#ifndef GWT_SECTIONTOEXECUTE_SEEN
#define GWT_SECTIONTOEXECUTE_SEEN

#include <Wt/WContainerWidget>
#include <Wt/WComboBox>
#include <Wt/WLabel>

class GWt_softwarePanel;

class GWt_sectionToExecute : public Wt::WContainerWidget
{
    public :
    GWt_sectionToExecute(Wt::WComboBox*,Wt::WComboBox*,Wt::WComboBox*,GWt_softwarePanel* sPanel);

    ~GWt_sectionToExecute() {;}

    inline Wt::WString getFirstElementCurrentText() {
        return firstElement->currentText();
    }
    
    inline Wt::WString getLastElementCurrentText() {
        return lastElement->currentText();
    }
    
    inline Wt::WString getSoftwareCurrentText() {
        return software->currentText();
    }
    
    inline Wt::WComboBox * getFirstElement() {
        return firstElement;
    }
    
    inline Wt::WComboBox * getLastElement() {
        return lastElement;
    }
    
    inline Wt::WComboBox * getSoftware() {
        return software;
    }
    void setFirstElementCurrentSelection(Wt::WString);
    void setLastElementCurrentSelection(Wt::WString);
    void setSoftwareElementCurrentSelection(Wt::WString);
    
    inline void setWarnings(Wt::WString warn){
        warningsLabel_->setText(warn);
        manageWarningsAndErrors();
    }

    inline void setErrors(Wt::WString err){
        errorsLabel_->setText(err);
        manageWarningsAndErrors();
    }

    private :
    
    void manageWarningsAndErrors();
    Wt::WComboBox*  firstElement;
    Wt::WComboBox*  lastElement;
    Wt::WComboBox* software;
    GWt_softwarePanel* softwarePanel;

    Wt::WLabel* errorsLabel_;
    Wt::WLabel* warningsLabel_;

    Wt::WContainerWidget* warningsContainer_;
    Wt::WContainerWidget* errorsContainer_;
};

#endif
